# Documentation module gestion des "relations entreprises"

Ce module permet à ses utilisateurs de retrouver et mémoriser toutes les relations entreprises dans un même endroit sous la forme d'une base interne.

Faire la commande <code>flask db upgrade</code> si la base n'est pas à jour.

## Principales fonctionnalités

Le module, intégrée à ScoDoc, fournit pour l'instant:

- Saisie et gestion des entreprises et contacts
- Saisie et gestion des offres de stage et d'apprentissage
- Envoi des offres aux responsables de formations
- Historique à propos des entreprises
- Historique des modifications des fiches entreprises
- Systemes de rôles

## Systemes de rôles

Ses rôles ne sont pas reliés à des département. Les rôles permettent aux utilisateurs d'avoir différentes permissions selon le rôle qu'il possède.

### Rôle ObservateurEntreprise

Permission de ce rôle:
- Voir l'application relations entreprises

### Rôle UtilisateurEntreprise

Permissions de ce rôle:
- Voir l'application relations entreprises
- Modifier les entreprises

### Rôle AdminEntreprise

Permissions de ce rôle:
- Voir l'application relations entreprises
- Modifier les entreprises
- Exporter les données de l'application relations entreprises (et importer)
- Envoyer des offres
- Valide les entreprises

## Saisie et gestion des entreprises et contacts

### Liste des entreprises

Les entreprises dans la base de données apparaissent alors dans une liste d'entreprise où leur SIRET est un lien vers leur fiche entreprise.

### Fiche entreprise

Chaque entreprises de la base possède une fiche entreprise avec dessus les informations de l'entreprise (SIRET, nom, adresse, code postal, pays), les contacts, les offres, les dernières opérations, l'historique concernant l'entreprise.

### Ajouter une entreprise

Pour ajouter une entreprise dans la base, il y a un bouton `Ajouter une entreprise` qui vous emmène vers un formulaire comportant 2 partie, la partie entreprise avec tous les champs sur l'entreprise (SIRET, nom, adresse, code postal, pays) puis la partie contact avec les champs concernant le contact de cette entreprise (nom, prenom, téléphone mail, poste, service) car il y a obligatoirement un contact pour chaque entreprise de la base avec au moins un moyen de contact (téléphone ou mail).

### Formulaire `Ajouter une entreprise` auto remplissant

En saisissant un SIRET dans le formulaire d'ajout d'entreprise, le formulaire peut auto remplir le formulaire si le SIRET saisi correspond à celle d'une entreprise.

Il auto remplit les champs: nom, adresse, code postal, pays.

### Modifier une entreprise

Pour modifier une entreprise, on peut le faire à partir de la liste des entreprises ou alors sur la fiche entreprise de l'entreprise avec le bouton `Modifier` sous les informations de l'entreprise. Toutes les informations de l'entreprise peuvent être modifiés sauf le SIRET.

Les champs sont préremplis avec les informations actuelles de l'entreprise

### Supprimer une entreprise

Pour supprimer une entreprise, on peut le faire à partir de la liste des entreprises ou alors sur la fiche entreprise de l'entreprise avec le bouton `Supprimer`. La suppression d'une entreprise efface tous les éléments reliés à l'entreprise. (offres, contacts, historique, fichiers)

### Validation d'une entreprise

Les administrateurs du module gestion des relations entreprises doivent valider les entreprises saisies par les utilisateurs pour qu'il soit affichés dans la liste des entreprises

### Ajouter un contact

On peut ajouter un contact à une entreprise avec le bouton `Ajouter contact` présent sur la fiche entreprise qui vous emmène vers un formulaire avec plusieurs champs (nom, prénom, téléphone, mail, poste, service). Les champs nom, prénom sont obligatoires. Il faut que le contact possède au moins un moyen de contact c'est-à-dire soit un téléphone, soit un mail. Le poste et le service dans lequel il travaille est optionel.

Les contacts ne peuvent pas avoir le même nom et prénom au sein d'une même entreprise.

### Modifier un contact

Pour modifier un contact, on peut le faire avec le bouton `Modifier contact` sous les informations du contact présent sur la fiche entreprise de celle-ci. Toutes les informations du peuvent être modifiés.

Les champs sont préremplis avec les informations actuelles du contact

### Supprimer un contact

Pour supprimer un contact, on peut le faire avec le bouton `Supprimer contact`. On peut supprimer tous les contacts tant qu'il en reste un (il faut un minimum de 1 contact par fiche entreprise)

### Page offres expirés

C'est une page qui regroupe toutes les offres dont la date d'expiration est passées. Elle est accessible sur chaque fiche entreprise avec le bouton `Voir les offres expirées`

### Pages contacts

C'est une page qui affiche la liste des contacts avec le nom de leur entreprise cliquable qui envoie sur la fiche entreprise de l'entreprise.

### Exportation des données

Toutes les listes (entreprises et contacts) sont exportables en .xlxs avec des boutons présents au dessus des listes: `Exporter la liste des entreprise`, `Exporter la liste des contacts` et `Exporter la liste des contacts avec leur entreprise`

### Importation de données

On peut importer une liste d'entreprises par fichier Excel (.xlxs) avec le bouton `Importer des entreprises` présent sur la page principale du module. L'importation réussie s'il passe les vérifications et sont directement ajoutés à la base. (pour l'instant sans le contact obligatoire)

## Saisie et gestion des offres de stage et d'apprentissage

### Visibilité d'une offre

Une offre peut etre lié à aucun ou plusieurs départements se qui change sa visibilité.

### Ajouter une offre

On peut ajouter une offre à une entreprise avec le bouton `Ajouter offre` présent sur la fiche entreprise qui vous emmène vers un formulaire avec plusieurs champs (intitulé, description, type de l'offre, missions, durée, départements et date d'expiration).

### Modifier une offre

Pour modifier une offre, on peut le faire avec le bouton `Modifier l'offre` sous les informations de l'offre présent sur la fiche entreprise de celle-ci. Toutes les informations du peuvent être modifiés.

Les champs sont préremplis avec les informations actuelles de l'offre

### Supprimer une offre

Pour supprimer une offre, on peut le faire avec le bouton `Supprimer l'offre`. On peut supprimer toutes les offres.

### Attacher un fichier à une offre existante

On peut attacher un ou plusieurs fichiers à une offre avec le lien `Ajoutez un fichier` sous les informations de l'offre qui vous emmène vers un formulaire ou il faut choisir le fichier à attaché. Les extensions de fichier acceptés sont .docx et .pdf

Le fichier est stocké sur le disque.

### Télécharger un fichier attaché

On peut télécharger un fichier attaché à une offre en cliquant sur le nom du fichier.

### Supprimer un fichier attaché a une offre existante

Chaque fichier attaché à une offre peut être supprimer (du disque)

## Historique des modifications des fiches entreprises

Toutes les opérations de création, modification, suppression est ajouté dans la liste des dernières opérations de toutes les entreprises et sur leur propre fiche entreprise qui sert d'historique des modifications.

## Ajouter un étudiant qui a déjà réalisé un stage ou une alternance au sein de l'entreprise

On peut ajouter un étudiant qui a déjà réalisé un stage ou une alternance au sein de l'entreprise avec le bouton `Ajouter historique` qui vous emmène vers un formulaire avec les champs étudiant (auto suggestion de nom d'étudiant selon la saisie), type de l'offre, date début et date fin.

## Envoi des offres aux responsables de formations

### Envoi des offres aux responsables

Sous chaque offre, il y a un bouton `Envoyer offre` qui permet d'envoyer une offre à un utilisateur de ScoDoc avec un champ (auto suggestion). Les offres envoyées arrivent sur la page des Offres reçues (`.../ScoDoc/entreprise/offres_recues`)

### Page offres reçues

La page des offres reçues affichent les offres qui ont été envoyés par d'autres utilisateurs ScoDoc.

### Fonctionnalités à venir

- API
- améliorations et nouvelles fonctionnalités à voir avec les utilisateurs