# Application "relations entreprises"

Cette application a pour but de permettre aux utilisateurs de retrouver et mémoriser toutes les relations entreprises dans un même endroit sous la forme d'une base interne à l'établissement.

Les utilisateurs interrogés insistent sur leur souhait d'avoir une interface simple et intuitive.


## Principales fonctionnalités

L'application, intégrée à ScoDoc, fournira:

- Saisie et gestion des entreprises
- Saisie et gestion des offres de stage et d'apprentissage
- Envoi des offres aux responsables de formations
- Historique à propos des entreprises
- Historique des modifications des fiches entreprises
- Journal de bord des étudiants pour suivre les candidatures


## Les utilisateurs

- le pôle des relations extérieures (le responsable, l'assistant, les chargés de relations entreprises)
- les secrétariats pédagogiques
- les responsables de stage
- les responsables de formations

Des actions et visibilités différentes selon le rôle de l'utilisateur (voir section "Rôles" plus loin).


## Les entreprises

Les entreprises possèderont chacune une fiche avec toutes leurs informations.

Lorsqu'un utilisateur souhaite indiquer une relation avec une entreprise ou 
a été contacté par une entreprise, il pourra saisir les informations de
l'entreprise dans la base si elle n'existe pas encore.
Si l'entreprise existe mais que l'utilisateur veut ajouter ou corriger des infos ? Ou ajouter un "correspondant" ? Peut-être un lien vers la modification de cette entreprise.


### Données sur l'entreprise:

- SIRET
- Nom
- Adresse, Code postal, Ville, Pays
- Élements de contact (nom, prénom, numéro de téléphone, email)

Ces élements de contacts sont associés à une personne ou un service (par exemple "ressources humaine") au sein de l'entreprise. Il y en aura donc un nombre variable.

Une entreprise peut avoir plusieurs éléments de contact, il peut s'agir d'une personne physique, du service ressources humaines d'une entreprise ou d'un autre service selon la situation.

Les entreprises sont identifiés par leur SIRET (unique) pour éviter les duplications et doivent toujours posséder des éléments de contact sinon inexploitable par les utilisateurs.

Les entreprises possède un SIRET pour chaque établissement de l'entreprise ce qui le rend unique, je pense donc que le SIRET est un bon moyen d'identifier une entreprise, peut-être mettre le SIREN aussi?

TODO: distinguer SIRET et SIREN, pour les grandes entreprises multi-sites voir https://www.economie.gouv.fr/entreprises/numeros-siren-siret

(Les établissements avec le même SIREN sont présent sur la même fiche entreprise avec chacun leur adresse)

Un historique sur l'entreprise pour pouvoir savoir quel étudiant a déjà réalisé un stage ou un contrat d'alternance au sein de l'entreprise avec:
- identifiant de l'étudiant INE ou ScoDoc id (`etudid`)
- type de contrat
- date début et fin
- formation de l'étudiant (texte)
- formation de l'étudiant: identifiant ScoDoc (`formsemestre_id`)

Un historique sur les modifications faites sur chaque fiche entreprise :
- modification adresse
- ajout/modification/suppression contact
- ajout/modification/suppression offre

L'ajout d'entreprise envoie un mail d'alerte au pole des relations extérieures.


## Les offres

Une entreprise peut proposer des offres.

Un utilisateur reçoit une offre d'une entreprise, il peut saisir l'offre dans la base qui sera ensuite affiché sur la fiche entreprise de celle ci. L'offre pourra ensuite être validé ou non par un responsable de formation s'il pense que les missions sont adéquates à la formation.

### Données sur les offres:

- Intitulé du poste
- Présentation?
- Type de l'offre
- Missions
- Durée

Chaque offre est reliée à une entreprise.

Les utilisateurs ont la possibilité d'envoyer les offres aux responsables de formations par la suite les responsables de formations diffusent l'offre au sein de leur formation.
Les responsables de formations ne sont reliés à aucun objet. Les utilisateurs envoient l'offre aux responsables de formations s'ils pensent que l'offre correspond bien à la formation.

L'ajout d'une offre envoie un mail d'alerte au responsable du pole des relations extérieures.


## Journal de bord

Journal de bord pour les étudiants afin de suivre leurs candidatures dans les offres envoyées préalablement par son responsable de formation.

Sur le journal de bord apparaîtra les offres que la responsable de formation a reçu et valider puis envoyer à ces étudiants. Les étudiants doit pouvoir saisir un commentaire s'il n'a candidaté a l'offre ou indiquer qu'il a candidater.

Les utilisateurs pourront avoir accès a ces journaux de bord pour constater l'avancée et l'implication des étudiants dans leurs candidatures.

Les étudiants accèdent au journal de bord en se connectant avec leur compte personnel et peuvent commenter chaque offre de stage/alternance.

Possibilités:
- Oui, j'ai candidaté (quand)
- Non, je n'ai pas candidaté (pourquoi)


Permettre aux entreprises d'avoir accès au bordereau de stage afin qu'il puisse le remplir (s'il compte déjà prendre un stagiaire) ou de proposer une offre de stage.
Un lien pour télécharger un bordereau de stage ajouté par les utilisateurs de l'application pour les entreprises.
XXX accès des entreprises: avec quel compte (identifiant). Quand et par qui ce compte est-il créé ? Je ne sais pas encore.

## Rôles et actions associées

2 rôles avec des droits différents.

Utilisateur possédant un rôle avec visibilité totale et toutes les actions possibles sur la base:
    - le pôle des relations extérieures avec le responsable, son assistant et les chargés de relations entreprises;
    - administrateur informatique.
    - directeur de l'IUT?

Utilisateur possédant un rôle avec seulement une visibilité sur la base selon le département dont il appartient :
    - les reponsables de formations
    - les secrétariat pédagogiques
    - les chefs de département
    - le responsable administratif

Role Observateur (juste visibité):
- Voir la liste des entreprises
- Voir la liste des contacts

Role Utilisateur de l'application? (quelques actions):
- Voir la liste des entreprises
- Voir la liste des contacts
- Ajouter une entreprise
- Modifier une entreprise
- Supprimer une entreprise
- Ajouter une offre
- Modifier une offre
- Supprimer une offre
- Ajouter un contact
- Modifier un contact
- Supprimer un contact
- Attacher des fichiers aux offres
- Supprimer des fichiers attachés aux offres
- Télécharger les fichiers des offres

Role Responsable de l'application (toutes les actions):
- Ajouter une entreprise
- Modifier une entreprise
- Supprimer une entreprise
- Ajouter une offre
- Modifier une offre
- Supprimer une offre
- Ajouter un contact
- Modifier un contact
- Supprimer un contact
- Voir la liste des entreprises
- Voir la liste des contacts
- Attacher des fichiers aux offres
- Supprimer des fichiers attachés aux offres
- Télécharger les fichiers des offres
- Exporter la liste des entreprises
- Exporter la liste des contacts
- Envoyer une offre

## Processus

Liste des principaux processus métiers identifiés: à préciser et compléter au cours du projet.

### Ajout d'une entreprise

 - Acteur: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
 - Quand: à tout moment.
 - Action: saisie des données sur une nouvelle entreprise, avec un point de contact
 - Déclenche: notification au chargés de relations entreprises (à toutes les personnes du pôle des relations extérieures).
 - Remarques: recherche d'entreprises ressemblantes pour éviter doublons.

### Modification d'une entreprise
- Acteur: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
- Quand: à tout moment.
- Action: modifie les données sur une entreprise.
- Déclenche: ajout des modifications dans un historique visible.
- Remarques: ...

### Consultation des entreprises
- Acteur: tout personnel autorisé.
- Quand: à tout moment.
- Action: moteur de recherche, liste des entreprises.
- Déclenche: rien.
- Remarques: ...

### Consultation des offres

 - Acteurs: tout personnel autorisé.
 - Quand: à tout moment.
 - Action: moteur de recherche, liste des offres de stages et d'alternance publiées.
 - Déclenche: rien.
 - Remarques: les offres devront impérativement avoir une date d'expiration pour éviter d'afficher ici des offres anciennes.
 
### Ajout d'une offre

 - Acteurs: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
 - Quand: à tout moment.
 - Action: saisie des données sur une nouvelle offre.
 - Déclenche: notification au chargés de relations entreprises (à toutes les personnes du pôle des relations extérieures).
 - Remarques: ...

### Validation d'une offre par un responsable de formation
- Acteur: les responsables de formation
- Quand: après la demande de validation d'une offre par le pôle des relations extérieures.
- Action: valide l'ajout d'une offre.
- Déclenche: notification au chargés de relations entreprises (à toutes les personnes du pôle des relations extérieures).
- Remarques: si l'ajout d'une offre est non validé, elle peut être modifier par la suite 

### Modification d'une offre
- Acteurs: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
- Quand: à tout moment.
- Action: modifie les données d'une offre.
- Déclenche: ajout des modifications dans un historique visible.
- Remarques: ...

### Suppression d'une offre
 - Acteurs: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
 - Quand: à tout moment.
 - Action: suppression d'une offre expiré (peut-être dans d'autre cas à voir)
 - Déclenche: notification au chargés de relations entreprises (à toutes les personnes du pôle des relations extérieures).
 - Remarques: ...

### Envoie d'une offre à un responsable de formation
 - Acteurs: tout personnel autorisé (le responsable et l' assistant du pôle des relations extérieures et les chargés de relations entreprises).
 - Quand: à tout moment.
 - Action: envoie d'une offre a un responsable de formation.
 - Déclenche: notification au responsable de formation.
 - Remarques: ...

### Envoie d'une offre aux étudiants par le responsable de formation
 - Acteurs: le responsable de formation.
 - Quand: après avoir reçu une offre de la part du pôle des relations extérieures
 - Action: envoie d'une offre aux étudiants d'une formation
 - Déclenche: notification aux étudiants, ajout de l'offre dans le journal de bord des étudiants afin qu'il puisse candidater et commenter leur candidature
 - Remarques: le responsable peut envoyer l'offre à tous ces élèves ou cibler les élèves.

### Consultation journal de bord des étudiants
 - Acteurs: tout personnel autorisé.
 - Quand: à tout moment.
 - Action: accès aux journaux de bord par formation.
 - Déclenche: rien.
 - Remarques: ...

### ...


## Échanges de données avec ScoDoc et autres composants du SI

Dans cette section, on préciser les besoins de l'appli "relations entreprises": points API avec ScoDoc et éventuellement d'autres composants du SI.

L'API de ScoDoc 9 étant en cours de rénovation, on précisera simplement, dans un premier temps, les besoins sans indiquer les points d'API précis. par exemple:
 - informations (dates, intitulés) sur une formation
 - informations sur les formations suivies par un étudiant identifié par son INE
 - récupérer l'id de l'utilisateur responsable d'une formation
 - ...

Réfléchir à l'utilisation (ou non) d'un accès à l'annuaire LDAP de l'établissement pour avoir les rôles. Une autre solution serait de se reposer sur ScoDoc pour avoir les id utilisateurs et les rôles.


## Idées

Possibilité aux entreprises de saisir leurs offres avec validation par le pôle des relations extérieures.

Possibilité d'importer des données déjà existantes (Excel).

## Architecture de l'application

 - Module ScoDoc (blueprint) offrant pages pour les personnels et API.

 - Module étudiant: séparé, interfacé via API (à définir plus tard)

 - Module entreprises: séparé, interfacé via API: à définir (plus tard ?)

## API

### Entreprises (idée de endpoints)

- `GET /ScoDoc/api/entreprises`
    - Résultat: Liste des entreprises

- `GET /ScoDoc/api/entreprises/contacts`
    - Résultat: Liste des contacts

- `GET /ScoDoc/api/entreprises/offres`
    - Résultat: Liste des offres

- `GET /ScoDoc/api/entreprises/<int:id>`
    - Résultat: Dictionnaire avec les informations de l'entreprise correspondant  à l'id passé en paramètre

- `GET /ScoDoc/api/entreprises/<int:entreprise_id>/offres`
    - Résultat: Liste des offres de l'entreprise correspondant à l'entreprise_id passé en paramètre

- `GET /ScoDoc/api/entreprises/<int:entreprise_id>/offres/<int:offre_id>`
    - Résultat: L'offre de l'entreprise correspondant aux id passé en paramètre

- `GET /ScoDoc/api/entreprises/<int:entreprise_id>/contacts`
    - Résultat: Liste des contacts de l'entreprise correspondant à l'entreprise_id passé en paramètre

- `GET /ScoDoc/api/entreprises/<int:entreprise_id>/contacts/<int:contact_id>`
    - Résultat: Le contact de l'entreprise correspondant aux id passé en paramètre